/*
Serial animater - using two analog inputs, control the position of an ellipse on the screen
also included are pieces to make sure we only recieve information when we want it
 */

import processing.serial.*;
import processing.video.*;
int[] inputs = new int[4]; 
Serial myPort;        // The serial port
String sensorValue;    // value of the byte received
float multiplied, movietime;
boolean madeContact = false;  //checks for contact with the serial port
int var1, var2, var3, var4, x, y;

Movie myMovie;        // variable to store an instance of the movie library
float movieDuration;  // duration of the movie you're using

void setup() {
  // set the window size:
  size(800,800);

  // List all the available serial ports
  //println(Serial.list());

  // I know that the first port in the serial list on my mac
  // is always my  Arduino module, so I open Serial.list()[0].
  // Change the 0 to the appropriate number of the serial port
  // that your microcontroller is attached to.
  myPort = new Serial(this, Serial.list()[0], 9600);

  // set the framerate for this sketch:
  frameRate(30);
}

void draw() {
  //if you havent connected to the serial port yet, send something, in this case, a carraige return
  if (madeContact == false) {
    myPort.write("r");
  }
  background(0);
  ellipse(x, y, 50, 50);

}

// serialEvent  method is run automatically by the Processing applet
// whenever the buffer reaches the  byte value set in the bufferUntil()
// method in the setup():

void serialEvent(Serial myPort){
  madeContact = true;
  String myString = myPort.readStringUntil(124); //the ascii value of the "|" character
  if(myString != null ){
    myString = trim(myString); //remove whitespace around our values
     inputs = int(split(myString, ','));
    //now assign your values in processing
    if(inputs.length == 5){
       var1 = inputs[0];
       var2 = inputs[1];
       var3 = inputs[2];
       var4 = inputs[3];
       x = var1 * 256 + var2 - 250;
       y = var3 * 256 + var4 - 100;
       myPort.write("r"); //this sends a command to ask for the next set of data
    }
  }
 
} 
